from OpenGL.GL import *
from OpenGL.GLU import *
import pygame
from pygame.locals import * 


def map_value(current_min, current_max, new_min, new_max, value):
    current_range = current_max - current_min
    new_range = new_max - new_min
    return new_min + new_range * ((value - current_min)/
                                  current_range)


class Button:
    def __init__(self, screen, position, width,
                 height, color,
                 o_color, p_color, on_click):
        self.screen = screen
        self.position = position
        self.width = width
        self.height = height
        self.normal_color = color
        self.over_color = o_color
        self.pressed_color = p_color
        self.on_click = on_click
        self.mouse_down = False

    def draw(self, events):

        # --------- lepiej przekazac mouse.pos i wymiary ekranu --------
        mouse_pos = pygame.mouse.get_pos()
        mx = map_value(0, 800, 0, 800, mouse_pos[0])
        my = map_value(0, 600, 600, 0, mouse_pos[1])
        # --------------------------------------------------------------

        

        glPushMatrix()
        glLoadIdentity()
        # jeśli kursor nad przyciskiem
        if self.position[0] < mx < (self.position[0] + self.width) and  self.position[1] < my < (self.position[1] + self.height):
            
            for event in events:
                if event.type == MOUSEBUTTONDOWN and \
                                event.button == 1:
                    self.mouse_down = True
                    self.on_click()

                elif event.type == MOUSEBUTTONUP and \
                                event.button == 1:
                    self.mouse_down = False

            if (self.mouse_down):
                glColor3f(self.pressed_color[0], self.pressed_color[1], self.pressed_color[2])
            else:
                glColor3f(self.over_color[0], self.over_color[1], self.over_color[2])
        else:
            glColor3f(self.normal_color[0], self.normal_color[1], self.normal_color[2])
        
        glBegin(GL_POLYGON)
        glVertex2f(self.position[0], self.position[1])
        glVertex2f(self.position[0] + self.width,
                    self.position[1])
        glVertex2f(self.position[0] + self.width,
                    self.position[1] + self.height)
        glVertex2f(self.position[0],
                    self.position[1] + self.height)
        glEnd()
        glPopMatrix()
