import pygame
from Mesh3D import *  # Importujemy naszą klasę Mesh3D z pliku Mesh3D.py
from pygame.locals import *
from OpenGL.GL import *
from OpenGL.GLU import *
from Object import *
from Transform import *
from Cube import *



pygame.init()  # Inicjujemy moduły Pygame

clock = pygame.time.Clock()
fps = 30

screen_width = 500
screen_height = 500
# Tworzymy okno 500×500 z trybem OpenGL i podwójnym buforowaniem
screen = pygame.display.set_mode((screen_width,
                                    screen_height),
                                    DOUBLEBUF|OPENGL)
pygame.display.set_caption('OpenGL in Python')
done = False
white = pygame.Color(255, 255, 255)
glLightfv(GL_LIGHT0, GL_AMBIENT,  (1, 0, 1, 1))  # np. fioletowe ambient
glLightfv(GL_LIGHT0, GL_DIFFUSE,  (1, 1, 0, 1))  # np. żółte diffuse
glLightfv(GL_LIGHT0, GL_SPECULAR, (0, 1, 0, 1))  # np. zielone specular

gluPerspective(60, screen_width / screen_height, 0.1, 100.0)

#glOrtho(-1, 1, 1, -1, 0.1, 50.0)
glTranslatef(0.0, 0.0, -3.5)

glMatrixMode(GL_PROJECTION)
glMatrixMode(GL_MODELVIEW)
glEnable(GL_DEPTH_TEST)  # bufor głębi – odrzucanie fragmentów zasłoniętych
glEnable(GL_LIGHTING)  # włączenie obsługi oświetlenia
glLight(GL_LIGHT0, GL_POSITION, (5, 5, 5, 1))
glEnable(GL_LIGHT0)
glMaterialfv(GL_FRONT, GL_DIFFUSE, (0, 1, 1, 0.5))
lum = 1 

newCube = Object("Cube")            # utworzenie obiektu o nazwie "Cube"
newCube.add_component(Transform((1, 0, -1), (5, 1,1,1)))       # dodanie komponentu Transform z pozycją (0,0,-1)
newCube.add_component(Cube(GL_POLYGON))  # dodanie komponentu mesha 3D

newerCube = Object("Cube")            # utworzenie obiektu o nazwie "Cube"
newerCube.add_component(Transform((-1, 0, -1), (5, -1,-1,-1)))       # dodanie komponentu Transform z pozycją (0,0,-1)
newerCube.add_component(Cube(GL_POLYGON))  # dodanie komponentu mesha 3D

font = pygame.font.Font(None, 16)
text_surface = font.render("", True, white) 
text_rect = text_surface.get_rect(center=(100, 100)) 

# Pętla główna aplikacji
while not done:
    events = pygame.event.get()
    for event in events:
        if event.type == pygame.QUIT:
            done = True  # Wyjście z pętli, gdy zamykamy okno

    # Czyścimy bufor koloru i bufor głębi
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT)

    newCube.update(events)
    newerCube.update(events)
    glMaterialfv(GL_FRONT, GL_DIFFUSE, (1, 0, 0, lum))

    lum += 0.2
    lum %= 1

    pygame.display.flip()  # Prezentujemy nowo narysowaną klatkę
    clock.tick(fps)
    print(f"tick={clock.tick(fps)}, fps={clock.get_fps()}")

    mouse_pos = pygame.mouse.get_pos()
    text_surface = font.render(f"x: {mouse_pos[0]}, y: {mouse_pos[1]}", True, white) 
    screen.blit(text_surface, text_rect)

pygame.quit()  # Sprzątanie i zakończenie programu